# StopInstances

## 1. API Description

This API (StopInstances) is used to shut down one or more virtual machine instances.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">You can only perform this operation on instances whose status is</mark> <mark style="color:blue;">`STOPPED`</mark> <mark style="color:blue;">and that are not in the recycle bin.</mark>
* <mark style="color:blue;">The instance status will become</mark> <mark style="color:blue;">`STOPPING`</mark> <mark style="color:blue;">when the API is called successfully and</mark> <mark style="color:blue;">`STOPPED`</mark> <mark style="color:blue;">when the instance is successfully shut down.</mark>
* <mark style="color:blue;">This API is an async API. A response is returned after the request is sent. However, it does not mean the shutdown has been completed. You can use</mark> [<mark style="color:purple;">`DescribeInstancesStatus`</mark>](https://docs.console.zenlayer.com/api-reference/compute/vm/virtual-machine-instance/describeinstancesstatus) <mark style="color:blue;">to query the status of the instance. If the status changes from</mark> <mark style="color:blue;">`STOPPING`</mark> <mark style="color:blue;">to</mark><mark style="color:blue;">`STOPPED`</mark><mark style="color:blue;">, it means that the instance has been shut down successfully. Any operations on the instances are not allowed while creating.</mark>
* <mark style="color:blue;">Batch operations are supported. The maximum number of instances in each request is 100.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                                                                                                                                                    |
| -------------- | -------- | --------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceIds    | Yes      | Array of String | <p>Instance ID(s).</p><p>To obtain the instance IDs, you can call DescribeInstancesStatus and look for instanceId in the response. The maximum number of instances in each request is 100.</p> |
| forceShutdown  | No       | Boolean         | <p>Whether to force shutdown.</p><p>If you don't specify a default is Yes.</p><p>Default value: true</p>                                                                                       |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Shut down two instances with specified IDs.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: StopInstances
<Common Request Params>

Request:
{
  "instanceIds": [
    "instanceId1",
    "instanceId2"
  ]
}

Response:
{
  "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
  "response": {
    "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                                | Description                                                     |
| ---------------- | ----------------------------------------- | --------------------------------------------------------------- |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND             | Instance does not exist.                                        |
| 403              | OPERATION\_DENIED\_INSTANCE\_RECYCLED     | Operations on instances in recycle bin are not supported.       |
| 403              | OPERATION\_DENIED\_INSTANCE\_NOT\_RUNNING | Only operations on instances in `RUNNING` status are supported. |
